﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using System.Text.RegularExpressions;
using System.Web.UI;

namespace UrlRewrite
{
    public class UrlRewrite : IHttpModule
    {

        #region IHttpModule 成员

        public void Dispose()
        {
            throw new NotImplementedException();
        }

        public void Init(HttpApplication context)
        {
            context.BeginRequest += new EventHandler(Application_BeginRequest);
            //context.PreRequestHandlerExecute += new EventHandler(Application_PreRequestHandlerExecute);
        }

        void Application_BeginRequest(object sender, EventArgs e)
        {
            HttpContext context = HttpContext.Current;

            // 取得当前请求的路径
            string path = context.Request.Path;

            string suffix = String.Empty;
            if (UrlRewriteConfigHelp.Enabled)
                suffix = UrlRewriteConfigHelp.Suffix;

            // 遍历所有的映射规则，进行映射处理 
            foreach (UrlRewriteConfigRule rule in UrlRewriteConfigHelp.Rules)
            {
                Regex regex = new Regex("^" + rule.Form + suffix + "$", RegexOptions.IgnoreCase);
                Match match = regex.Match(path);
                if (match.Success)
                {
                    string trueUrl = UrlRewriteConfigHelp.RewriteBase + rule.To;

                    context.Items["OriginalUrl"] = context.Request.RawUrl;

                    if ("POST".Equals(context.Request.HttpMethod))
                        trueUrl = trueUrl.Substring(0, trueUrl.LastIndexOf("?"));
                    else
                    {
                        int count = match.Groups.Count;

                        if (count > 1 && match.Groups[1].Value != "")
                        {
                            for (int i = 1; i <= count; i++)
                            {
                                trueUrl = trueUrl.Replace("$" + i, match.Groups[i + 1].Value);
                            }
                        }
                    }

                    context.RewritePath(trueUrl);
                    return;
                }
            }

            //context.RewritePath("/error.htm");
        }

        //void Application_PreRequestHandlerExecute(object sender, EventArgs e)
        //{
        //    HttpContext context = HttpContext.Current;
        //    if (context.CurrentHandler is Page)
        //    {
        //        Page page = context.CurrentHandler as Page;
        //        page.PreInit += new EventHandler(Page_PreInit);
        //    }
        //}

        //void Page_PreInit(object sender, EventArgs e)
        //{
        //    HttpContext context = HttpContext.Current;
        //    if (context.Items.Contains("OriginalUrl"))
        //    {
        //        context.RewritePath(context.Items["OriginalUrl"] as string);
        //    }
        //}

        #endregion
    }
}
